// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


using System;
using svs.Mobile.BeyondMedia.FeedCore;

namespace svs.Mobile.BeyondMedia
{
	public class CmdArgs
	{
		private FeedCategory _CategoryToUpdate = CategoryManager.CategoryNull;
		private bool _ExitAfterUpdate = false;
		private bool _ShowUI = true;

		public CmdArgs()
		{
			
		}

		public CmdArgs(string[] args)
		{
			foreach (string s in args)
			{
				if (string.Compare(s, "noui", StringComparison.InvariantCultureIgnoreCase) == 0)
				{
					_ShowUI = false;
					_ExitAfterUpdate = true;
				}
				else if (string.Compare(s, "autoexit", StringComparison.InvariantCultureIgnoreCase) == 0)
				{
					_ExitAfterUpdate = true;
				}
				else
				{
					string cat = s.Trim();
					CategoryToUpdate = cat == "BPALLFEEDS"? CategoryManager.AllFeeds:CategoryManager.GetCategoryByValue(s.Trim());
				}
			}
		}

		public FeedCategory CategoryToUpdate
		{
			get { return _CategoryToUpdate; }
			set { _CategoryToUpdate = value; }
		}

		public bool ShowUI
		{
			get { return _ShowUI; }
			set { _ShowUI = value; }
		}

		public bool ExitAfterUpdate
		{
			get { return _ExitAfterUpdate; }
			set { _ExitAfterUpdate = value; }
		}
	}
}