﻿// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


using System;
using svs.Mobile.BeyondMedia.FeedCore;
using svs.Mobile.BeyondMedia.Objects;

namespace svs.Mobile.BeyondMedia.Controls
{
	internal interface IFeedsView : IView
	{
		/// <summary>
		/// Gets the selected feed.
		/// </summary>
		/// <value>The selected feed.</value>
		Feed SelectedFeed { get; set; }

		/// <summary>
		/// The current Feed
		/// </summary>
		Feed Feed { get; }

		void SetRootFeed(Feed root, Feed selected);

		event Helpers.FeedSelectedEvent Select;
		event Helpers.NavigationEvent Navigation;
		event EventHandler BackClick;
		event EventHandler SelectedIndexChanged;
		event EventHandler ReturnLongPress;

		void Clear();
		void Reload();

		Feed GetNextUnreadFeed();
		Feed GetNextFeed();
		Feed GetPreviousFeed();
		void NotifyFeedStatusChanged(Feed feed);
	}
}