// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


using System;
using svs.Mobile.BeyondMedia.FeedCore;
using svs.Mobile.BeyondMedia.FeedCore.Helpers;
using svs.Mobile.BeyondMedia.Objects;

namespace svs.Mobile.BeyondMedia.Controls
{
	internal interface ITracksView
	{
		event EventHandler BackClick;
		event Helpers.TrackSelectedEvent Select;
		event Helpers.NavigationEvent Navigation;

		/// <summary>
		/// Gets the current playlist.
		/// </summary>
		/// <value>The current playlist.</value>
		TrackList CurrentPlaylist { get; }

		Track SelectedTrack { get; set; }
		
		/// <summary>
		/// Plays the selected.
		/// </summary>
		void PlaySelected();

		/// <summary>
		/// Clears this instance.
		/// </summary>
		void Clear();

		void Reload();

		/// <summary>
		/// True if the view is showing data for a given feed
		/// </summary>
		/// <param name="feed"></param>
		/// <returns></returns>
		bool IsShowingFeed(Feed feed);

		void ClearFeedFilter();
		Feed GetFeedFilter();
		void SetFeedFilter(Feed feed);
		bool HasFeedFilter();
		void SelectNextTrack();
		void NotifyTrackStatusChanged(Track track);

	}
}