// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


using System;
using svs.Mobile.BeyondMedia.FeedCore;
using svs.Mobile.BeyondMedia.Objects;

namespace svs.Mobile.BeyondMedia.Controls.Players
{
	/// <summary>
	/// Dymmy player stub - no functionality
	/// </summary>
	internal class NullPlayer : IPlayerControl
	{
		#region IPlayerControl Members

#pragma warning disable 67

		public event EventHandler BackClick;

		public event EventHandler StreamPositionChange;

		public event EventHandler PlayError;

		public event EventHandler MediaEnd;

		public event EventHandler StartPlaying;

		public event EventHandler Paused;

		public event EventHandler Stopped;

#pragma warning restore 67

		public void ChangeVolume(Helpers.MoveDirection i_direction)
		{
			return;
		}

		public void Skip(Helpers.MoveDirection i_direction, int i_duration)
		{
			return;
		}

		public void Pause()
		{
			return;
		}

		public void Play()
		{
			return;
		}

		public void Stop()
		{
			return;
		}

		public void PlayTrack(Track track)
		{
			return;
		}

		public void CloseStream()
		{
			return;
		}

		public void SaveCurrentPosition(Track.PlayMode i_mode)
		{
			return;
		}

		public void OnClosing()
		{
			return;
		}

		public void OnSkinChanged(ISkin skin)
		{
			return;
		}

		public Track CurrentTrack
		{
			get { return null; }
			set { return; }
		}

		public bool IsPlaying
		{
			get { return false; }
		}

		public bool IsPaused
		{
			get { return false; }
		}

		public double CurrentStreamPosition
		{
			get { return -1; }
			set { return; }
		}

		public double CurrentStreamDuration
		{
			get { return -1; }
		}

		public string PlayerVersion
		{
			get { return "N/A"; }
		}

		public int VolumeLevel
		{
			get { return -1; }
			set { return; }
		}

		public bool Visible
		{
			get { return false; }
			set { return; }
		}

		public int Height
		{
			get { return 0; }
			set { return; }
		}

		public int Width
		{
			get { return 0; }
			set { return; }
		}

		public int Top
		{
			get { return 0; }
			set { return; }
		}

		public int Left
		{
			get { return 0; }
			set { return; }
		}

		#endregion
	}
}