// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


using System.Drawing;
using System.Windows.Forms;

namespace svs.Mobile.BeyondMedia.Objects
{
	internal interface IView
	{
		/// <summary>
		/// Gets the title.
		/// </summary>
		/// <value>The title.</value>
		string Title { get; }

		/// <summary>
		/// Gets the view menu.
		/// </summary>
		/// <value>The view menu.</value>
		MainMenu ViewMenu { get; }

		/// <summary>
		/// Shows or Hides the view
		/// </summary>
		bool Visible { get; set; }

		/// <summary>
		/// Sets the focus to the view
		/// </summary>
		bool Focus();

		/// <summary>
		/// Notifies the view that it will be activated
		/// </summary>
		void OnBeforeActivate();

		/// <summary>
		/// Notifies the view that it was deactivated
		/// </summary>
		void OnAfterDeactivate();

		/// <summary>
		/// Notifies that the view was activated
		/// </summary>
		void OnAfterActivate();

		/// <summary>
		/// Gets a screenshot of the view for transitions
		/// </summary>
		/// <returns></returns>
		Bitmap CreateScreenShot();
		
	}
}