// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


/*
 * Created by: Stefan Kyntchev
 * Created: Monday, February 26, 2007
 */

using System.Collections.Generic;
using svs.Mobile.BeyondMedia.FeedCore.RSS.Templates;

namespace svs.Mobile.BeyondMedia.FeedCore.RSS.Templates
{
	public class FeedTemplate : TemplateBase
	{
		private static List<KeyValuePair<string, string>> m_Template;

		public FeedTemplate(TemplateTypes type) : base(type)
		{
		}

		public override List<KeyValuePair<string, string>> Template
		{
			get
			{
				if (m_Template == null)
				{
					m_TemplateFileName = "RSSFeed.htm";
					m_Template = LoadTemplate();
				}
				return m_Template;
			}
		}
		/// <summary>
		/// The name of the feed
		/// </summary>
		public string Title
		{
			set
			{
				m_Parameters["#FEED_TITLE#"] = value;
			}
			get
			{
				return m_Parameters["#FEED_TITLE#"];
			}
		}

		/// <summary>
		/// The Description of the feed
		/// </summary>
		public string Description
		{
			set
			{
				m_Parameters["#FEED_DESCRIPTION#"] = value;
			}
			get
			{
				return m_Parameters["#FEED_DESCRIPTION#"];
			}
		}

		/// <summary>
		/// The Link to the feed URL
		/// </summary>
		public string Link
		{
			set
			{
				m_Parameters["#FEED_LINK#"] = value;
			}
			get
			{
				return m_Parameters["#FEED_LINK#"];
			}
		}


		/// <summary>
		/// The amount of free space at the download location
		/// </summary>
		public string FreeSpaceForDownload
		{
			set
			{
				m_Parameters["#FREE_SPACE_FOR_DOWNLOAD#"] = value;
			}
			get
			{
				return m_Parameters["#FREE_SPACE_FOR_DOWNLOAD#"];
			}
		}

		// <summary>
		/// The Description of the feed
		/// </summary>
		public string LastBuildDate
		{
			set
			{
				m_Parameters["#FEED_LAST_BUILD_DATE#"] = value;
			}
			get
			{
				return m_Parameters["#FEED_LAST_BUILD_DATE#"];
			}
		}

		/// <summary>
		/// Link to download all podcasts for the feed
		/// </summary>
		public string DownloadAllText
		{
			set
			{
				m_Parameters["#DOWNLOAD_ALL#"] = value;
			}
			get
			{
				return m_Parameters["#DOWNLOAD_ALL#"];
			}
		}

		/// <summary>
		/// Link to show all podcasts for the feed
		/// </summary>
		public string ShowAllText
		{
			set
			{
				m_Parameters["#SHOW_ALL#"] = value;
			}
			get
			{
				return m_Parameters["#SHOW_ALL#"];
			}
		}

		public string LinkPrefix
		{
			set
			{
				m_Parameters["#FEEDITEM_LINK_PREFIX#"] = value;
			}
			get
			{
				return m_Parameters["#FEEDITEM_LINK_PREFIX#"];
			}
		}

		public static void RefreshTemplate()
		{
			m_Template = null;
		}

	}
}