// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


/*
 * Created by: Stefan Kyntchev
 * Created: Monday, February 26, 2007
 */

using System;
using System.Collections.Generic;
using System.IO;

namespace svs.Mobile.BeyondMedia.FeedCore.RSS.Templates
{
	public class InfoMessageTemplate : TemplateBase
	{
		private static List<KeyValuePair<string, string>> m_Template;

		public InfoMessageTemplate(TemplateTypes type) : base(type)
		{
			m_Parameters["#SYS_COLOR_A#"] = CoreHelper.SYS_COLOR_A;
		}

		public override List<KeyValuePair<string, string>> Template
		{
			get
			{
				if (m_Template == null)
				{
					m_TemplateFileName = "InfoMessage.htm";
					m_Template = LoadTemplate();
				}
				return m_Template;
			}
		}

		/// <summary>
		/// The name of the feed
		/// </summary>
		public string FeedName
		{
			set { m_Parameters["#FEED_NAME#"] = value; }
			get { return m_Parameters["#FEED_NAME#"]; }
		}

		public bool SaveAsHtml(string SavePath)
		{
			StreamWriter writer = null;
			try
			{
				FileStream fs = new FileStream(SavePath, FileMode.Create, FileAccess.Write, FileShare.Read);
				writer = new StreamWriter(fs);
				ToHtml(writer);
				return true;
			}
			catch (Exception ex)
			{
				CoreHelper.WriteLogEntry("Unable to write to " + SavePath + "! Reason: " + ex);
			}
			finally
			{
				if (writer != null)
					writer.Close();
			}

			return false;
		}

		public static void RefreshTemplate()
		{
			m_Template = null;
		}
	}
}