// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


using Microsoft.WindowsMobile.Status;
using svs.Mobile.BeyondScheduler.Core;
using svs.Mobile.BeyondScheduler.Core.Objects;

namespace svs.Mobile.BeyondScheduler.Runner
{
	internal class Program
	{
		private static void Main(string[] args)
		{
			if (args.Length > 0)
			{
				CoreHelper.WriteLogEntry(" ");
				CoreHelper.WriteLogEntry(
					string.Format("Starting scheduled run for: {0}. Battery Level: {1} ({2})", args[0],
					              SystemState.PowerBatteryStrength, SystemState.PowerBatteryState));
				
				OnScheduledRun(args[0]);

				CoreHelper.WriteLogEntry("Scheduled run completed!");
			}
			else
				CoreHelper.WriteLogEntry("Scheduler was started with no command line parameters!");
		}

		private static void OnScheduledRun(string arg)
		{
			if (!TaskRepository.ExecuteTaskFor(arg))
				CoreHelper.WriteLogEntry("Nothing to do!");
		}
	}
}