// --- Copyright (c) 2006-2008 Stefan Kyntchev ---
// This software is written and copyrighted by Stefan Kyntchev 
// and BeyondPod Team members. All rights are reserved.
// Author contact: support@beyondpod.mobi
// ------------------------------------------------------------------------
// This file is part of BeyondPod RSS Feed Reader and Podcast manager
// (www.codeplex.com/BeyondPod) 
// BeyondPod is free software: you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation, either version 3 of the License, or 
// (at your option) any later version. 
//  
// BeyondPod is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//  
// You should have received a copy of the GNU General Public License
// along with BeyondPod. If not, see <http://www.gnu.org/licenses/>
// ------------------------------------------------------------------------
// COPYRIGHT NOTICE: This copyright notice may NOT be removed, obscured or modified 
// without written consent from the author.
// --- End copyright notice --- 


#region References

using System;
using System.Collections.Generic;
using System.Windows.Forms;

#endregion

namespace svs.Mobile.BeyondScheduler.Core.Objects.Operations.OperationUIs
{
	public partial class OperationStartBeyondPodUpdateUI : Form
	{
		public OperationStartBeyondPodUpdateUI()
		{
			InitializeComponent();
		}

		private void OnLoad(object sender, EventArgs e)
		{
			CategoryToUpdate.DataSource = CategoryManagerLite.Load();
			CategoryToUpdate.SelectedItem = SelectedCategory;
			CategoryToUpdate.Focus();
		}

		private void menuCancel_Click(object sender, EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
		}

		private void menuDone_Click(object sender, EventArgs e)
		{
			SelectedCategory = CategoryToUpdate.SelectedItem as String;
			DialogResult = DialogResult.OK;
		}

		public string SelectedCategory { get; set; }
	}

	public static class CategoryManagerLite
	{
		public static List<string> Load()
		{
			var retVal = new List<string>(Configuration.FeedCategories.Split(new[] {'|'}));
			retVal.Sort();
			retVal.Insert(0, "All feeds");
			return retVal;
		}
	}
}